/*
 * ToGrammarLeftRG.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Tomas Pecka
 */

#ifndef __TO_GRAMMAR_LEFT_RG_H__
#define __TO_GRAMMAR_LEFT_RG_H__

#include <grammar/Regular/LeftRG.h>
#include <automaton/FSM/NFA.h>
#include <automaton/FSM/DFA.h>

#include <grammar/Grammar.h>
#include <automaton/Automaton.h>

namespace automaton {

namespace convert {

/**
 * Finite automaton to right regular grammar converter.
 * Source: My own :)
 */
class ToGrammarLeftRG : public automaton::VisitableConstFSMBase {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static grammar::Grammar convert(const automaton::Automaton& automaton);

	static grammar::LeftRG convert(const automaton::NFA& automaton);
	static grammar::LeftRG convert(const automaton::DFA& automaton);

private:
	void Visit(void*, const automaton::EpsilonNFA& automaton) const;
	void Visit(void*, const automaton::MultiInitialStateNFA& automaton) const;
	void Visit(void*, const automaton::NFA& automaton) const;
	void Visit(void*, const automaton::DFA& automaton) const;
	void Visit(void*, const automaton::ExtendedNFA& automaton) const;
	void Visit(void*, const automaton::CompactNFA& automaton) const;

	static const ToGrammarLeftRG TO_GRAMMAR_LEFT_RG;
};

} /* namespace convert */

} /* namespace automaton */

#endif /* __TO_GRAMMAR_LEFT_RG_H__ */
